#if !defined(MV_CONFIGURATION_H)

#define MV_CONFIGURATION_H

#ifdef RAID_DRIVER

/* OSD macro definition */
#define MV_MAX_TRANSFER_SIZE	(128*1024)
#define MAX_REQUEST_NUMBER		32
#define MAX_BASE_ADDRESS		6

/* Core driver macro definition */
#define MAX_SG_ENTRY			32

//#define ENABLE_PATA_ERROR_INTERRUPT

/* It's dangerous. Never enable it unless we have to. */
#define PRD_SIZE_WORD_ALIGN	

/* 
 * For ATAPI device, we can choose 
 * 1. Enable USE_PIO_FOR_ALL_PACKET_COMMAND
 * 2. Enable USE_DMA_FOR_ALL_PACKET_COMMAND
 * 3. Don't enable either of them. It'll use DMA for read/write. Others will use PIO.
 * So far, USE_DMA_FOR_ALL_PACKET_COMMAND is the best choice.
 */
//#define USE_PIO_FOR_ALL_PACKET_COMMAND
#define USE_DMA_FOR_ALL_PACKET_COMMAND

//#define HIBERNATION_ROUNTINE

#define CORE_SUPPORT_API      1

/* for Simulation */
//#define USE_VIRTUAL_PRD_TABLE	1

/* pass through */
/*#define SUPPORT_SCSI_PASSTHROUGH  1*/
#define SUPPORT_EVENT			  1

/* RAID */

/* now controlled by Makefile - A.C. July 10th, 2006
  #define RAID_DRIVER		1 */

#define BGA_SUPPORT		1
#define SOFTWARE_XOR	1
#define SUPPORT_FREE_POLICY		1

/* hot plug & PM */
#define SUPPORT_HOT_PLUG	1
#define SUPPORT_PM			1

//#define SUPPORT_TIMER				1
#define SUPPORT_ERROR_HANDLING		1

#ifndef __MV_LINUX__
#define SUPPORT_CONSOLIDATE	1
#endif /* __MV_LINUX__ */

#ifdef SUPPORT_SCSI_PASSTHROUGH		
#define MV_MAX_TARGET_NUMBER		21		// console
#else
#define MV_MAX_TARGET_NUMBER		20		// max 5 ports, 4 device each
#endif
#define MV_MAX_LUN_NUMBER			1

//#ifdef RAID_DRIVER
#define CONSOLE_ID					(MV_MAX_TARGET_NUMBER - 1) * MV_MAX_LUN_NUMBER
//#endif

#else /* RAID_DRIVER */

/*From Non-RAID for Windows*/
/* OSD macro definition */
#define MV_MAX_TRANSFER_SIZE	(128*1024)
#define MAX_REQUEST_NUMBER		32
#define MAX_BASE_ADDRESS		6

/* Core driver macro definition */
#define MAX_HD_NUMBER			32
#define MAX_SG_ENTRY			32

//#define ENABLE_PATA_ERROR_INTERRUPT

/* It's dangerous. Never enable it unless we have to. */
#define PRD_SIZE_WORD_ALIGN	

/* 
 * For ATAPI device, we can choose 
 * 1. Enable USE_PIO_FOR_ALL_PACKET_COMMAND
 * 2. Enable USE_DMA_FOR_ALL_PACKET_COMMAND
 * 3. Don't enable either of them. It'll use DMA for read/write. Others will use PIO.
 * So far, USE_DMA_FOR_ALL_PACKET_COMMAND is the best choice.
 */
//#define USE_PIO_FOR_ALL_PACKET_COMMAND
#define USE_DMA_FOR_ALL_PACKET_COMMAND

//#define HIBERNATION_ROUNTINE

//#define CORE_SUPPORT_API

//#define SUPPORT_SCSI_PASSTHROUGH

#define SUPPORT_ERROR_HANDLING		1

#ifndef __MV_LINUX__
#define SUPPORT_CONSOLIDATE 1
#endif /* __MV_LINUX__ */

/* hot plug & PM */
#define SUPPORT_HOT_PLUG
#define SUPPORT_PM

//#define SUPPORT_TIMER

#ifdef SUPPORT_SCSI_PASSTHROUGH		
#define MV_MAX_TARGET_NUMBER		21		// console
#else
#define MV_MAX_TARGET_NUMBER		20		// max 5 ports, 4 device each
#endif

#define MV_MAX_LUN_NUMBER			1
#define CONSOLE_ID					MV_MAX_TARGET_NUMBER-1

#endif

#endif /* MV_CONFIGURATION_H */
