#if !defined(__RAID_MANAGE_H__)
#define __RAID_MANAGE_H__

#ifndef _OS_BIOS
extern RAID_Management_Command_Handler raid_ld_cmd_handler[];
extern RAID_Management_Command_Handler raid_pd_cmd_handler[];
#endif

MV_U8 raid_get_PD_info_specific(PRAID_Core pRaidCore, MV_U16 deviceId, MV_U8 pdIdx);
void raid_get_configuration(PRAID_Core pRaidCore);
void raid_ld_request_create(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_create_initialize(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_check_each_ld(PRAID_Core pRaidCore, MV_U8 ldId, MV_U8 notifyFlag, MV_U8 powerOnFlag);
void raid_check_all_ld(PRAID_Core pRaidCore, MV_U8 notifyFlag, MV_U8 powerOnFlag);
void raid_pd_plug_out(PRAID_Core pRaidCore, MV_U16 deviceId, MV_U8 wipeFlag);
void raid_ld_request_get_max_size(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_delete(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_get_status(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_get_config(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_set_config(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_wipe_out_pd(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_get_spare_status(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_set_global_spare(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_remove_spare(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_set_pd_status(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_shutdown(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_hd_free_space(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_get_hd_mbr(PRAID_Core pRaidCore, PMV_Request pMvReq);

#ifdef BGA_SUPPORT
void raid_ld_request_rebuild(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_synchronization(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_initialization(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_migration(PRAID_Core pRaidCore, PMV_Request pMvReq);
void raid_ld_request_BGA_control(PRAID_Core pRaidCore, PMV_Request pMvReq);

#endif

void raid_delete_rdisk(PRAID_Core pRaidCore, PRAID_Configure pRaidConf);

#endif /* __RAID_MANAGE_H__ */

