#ifndef __RAID_RES_MGMT_H__
#define __RAID_RES_MGMT_H__

PRAID_Request raid_get_req_from_CRpool(PRAID_Core pRaidCore);
void raid_release_req_to_CRpool(PRAID_Core pRaidCore, PRAID_Request pRaidReq);

PMV_Request raid_get_MVReq_from_pool(PRAID_Core pRaidCore);
void raid_release_MVReq_to_pool(PRAID_Core pRaidCore, PMV_Request pMvReq);
PMV_Request raid_get_MVReq_from_queue(List_Head *pQueue);

PMV_XOR_Request raid_get_XorReq_from_pool(PRAID_Core pRaidCore);
void raid_release_XorReq_to_pool(PRAID_Core pRaidCore, PMV_XOR_Request pXorReq);
PMV_XOR_Request raid_get_XorReq_from_queue(List_Head *pQueue);

PScratch_Buffer raid_get_SBuf(PRAID_Core pRaidCore);
PScratch_Buffer raid_get_SBuf_reserved(PRAID_Core pRaidCore);
PScratch_Buffer raid_get_multiple_SBuf(PRAID_Core pRaidCore, MV_U32 sectorCount);
void raid_release_SBuf(PRAID_Core pRaidCore, PScratch_Buffer pSBuf);
void raid_release_multiple_SBuf(PRAID_Core pRaidCore, PScratch_Buffer pSBuf);

MV_PVOID raid_get_node_from_pool(PNode_Pool pCurrentPool, MV_U8 nodeCount, MV_U8 typeFlag);
void raid_release_node_to_pool(PNode_Pool pCurrentPool, MV_PVOID pNode, MV_U8 typeFlag);
void raid_release_request_in_queue(PRAID_Core pRaidCore, List_Head *pQueue, MV_U8 seqType);

//TBD: For debug only. Can be removed.
void raid_check_SBuf_count(PScratch_Buffer pBuffer, MV_U32 count);

//MV_U8 raid_get_free_SBuf_Count(PRAID_Core pRaidCore);

#endif
