#if !defined(__RAID_SEQ_H__)
#define __RAID_SEQ_H__

void raid_seq_disk_access(PRAID_Core pRaidCore, PSequence_Info pSeqNode);
void raid_seq_xor_access(PRAID_Core pRaidCore, PSequence_Info pSeqNode);
void raid_seq_terminate(PRAID_Core pRaidCore, PSequence_Info pSeqNode);
void raid_seq_null(PRAID_Core pRaidCore, PSequence_Info pSeqNode);
#ifdef BGA_SUPPORT
void raid_seq_sync_write(PRAID_Core pRaidCore, PSequence_Info pSeqNode);
#endif

void raid_disk_access_callback(PRAID_Core pRaidCore, PMV_Request pMvReq);


PMV_Request raid_construct_disk_request(
	PRAID_Core		pRaidCore,
	PSequence_Info	pSeqNode,
	PBlock_Disk		pBlkDisk,
	PMap_Info		pMapNode,
	PMV_SG_Entry	*p_pOrgSGEntry,
	MV_PU32			pOffsetInByte,
	MV_U8			opCode
);

PMV_Request raid_append_disk_request(
	PRAID_Core		pRaidCore,
	PMV_Request		pMvReq,
	PSequence_Info	pSeqNode,
	PBlock_Disk		pBlkDisk,
	PMap_Info		pMapNode,
	PMV_SG_Entry	*p_pOrgSGEntry,
	MV_PU32			pOffsetInByte,
	MV_U8			opCode
);

PMV_XOR_Request raid_construct_xor_request(
	PRAID_Core		pRaidCore,
	PSequence_Info	pXorSeqNode,
	MV_U8			xorType
);
MV_U8 raid_select_raid1_read_disk(
	PBlock_Disk		pDataBlkDisk,
	PBlock_Disk		pMirrorBlkDisk
);

#endif /* __RAID_SEQ_H__ */
